import type { Adapter, AdapterRequestContext, DispatchResourceRequestContext, ErrorResponse, FulfilledSnapshot, Luvio, FetchResponse, Snapshot, SnapshotRefresh, StaleSnapshot } from '@luvio/engine';
import type { ResourceRequestConfig } from '../../generated/resources/postByApexMethodAndApexClass';
import type { ApexAdapterConfig, ApexInvokerParams } from '../../util/shared';
export declare function createResourceParams(config: ApexAdapterConfig): ResourceRequestConfig;
export declare function keyBuilderFromResourceParams(params: ResourceRequestConfig): string;
export declare function ingestSuccess(luvio: Luvio, resourceParams: ResourceRequestConfig, response: FetchResponse<any>, snapshotRefresh?: SnapshotRefresh<any>): FulfilledSnapshot<any, any> | StaleSnapshot<any, any>;
export declare function onFetchResponseSuccess(luvio: Luvio, _config: ApexAdapterConfig, resourceParams: ResourceRequestConfig, response: FetchResponse<any>): Promise<FulfilledSnapshot<any, any> | StaleSnapshot<any, any>>;
export declare function onFetchResponseError(luvio: Luvio, _config: ApexAdapterConfig, _resourceParams: ResourceRequestConfig, response: ErrorResponse): Promise<import("@luvio/engine").ErrorSnapshot>;
export declare function buildNetworkSnapshot(luvio: Luvio, config: ApexAdapterConfig, options?: DispatchResourceRequestContext): Promise<Snapshot<any>>;
type ApexInvoker = (config: unknown, requestContext: AdapterRequestContext) => Promise<any>;
export type ApexAdapterFactory<Config, DataType> = (luvio: Luvio, namespace: string, classname: string, method: string, isContinuation: boolean) => Adapter<Config, DataType>;
export declare const postInvoker: (luvio: Luvio, invokerParams: ApexInvokerParams) => ApexInvoker;
export declare const getInvoker: (luvio: Luvio, invokerParams: ApexInvokerParams) => ApexInvoker;
export {};
